Debian Bug report logs - #622276
gcc-mingw-w64: architecture triplets don't seem to make sense

version graph

Package: gcc-mingw-w64; Maintainer for gcc-mingw-w64 is Stephen Kitt <skitt@debian.org>; Source for gcc-mingw-w64 is src:gcc-mingw-w64.

Reported by: Adam Borowski <kilobyte@angband.pl>

Date: Mon, 11 Apr 2011 17:18:07 UTC

Severity: normal

Tags: wontfix

Found in version 4.5.2-8

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, unknown-package@qa.debian.org:
Bug#622276; Package gcc-mingw-w64. (Mon, 11 Apr 2011 17:18:17 GMT) Full text and rfc822 format available.

Acknowledgement sent to Adam Borowski <kilobyte@angband.pl>:
New Bug report received and forwarded. Copy sent to unknown-package@qa.debian.org. (Mon, 11 Apr 2011 17:18:18 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Adam Borowski <kilobyte@angband.pl>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: gcc-mingw-w64: architecture triplets don't seem to make sense
Date: Mon, 11 Apr 2011 19:14:32 +0200
Package: gcc-mingw-w64
Version: 4.5.2-8
Severity: normal

Hi!

(Reporting while the package is still stuck in NEW, sorry if it becomes
misplaced.  Reportbug claims the maintainer is ok, not sure about the BTS.)

The compiler triplets seem to be wrong:

* i686-w64-mingw32 has "w64" in name, yet executables it produces work
  perfectly on 32 bit systems.  I even checked on an ancient 32 bit only   
  machine to be 100% sure.

  To add confusion, other builds call it i586-mingw32msvc or just mingw32.

* x86_64-w64-mingw32 has "w32", but its executables are 64 bit.


Not to mention the whole package being named *-mingw-w64 while its existing
counterparts have "-w" less (-mingw32), but that'd be probably too much work
to change at this point.  This inconsistency has nowhere as big potential
for confusion as -w64- in the 32 bit compiler.



-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'stable'), (150, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.26-2-vserver-amd64 (SMP w/4 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages gcc-mingw-w64 depends on:
ii  binutils-mingw-w64     2.21.0.20110327-2 Cross-binutils for Win32 and Win64
ii  libc6                  2.11.2-13         Embedded GNU C Library: Shared lib
ii  libgmp10               2:5.0.1+dfsg-7    Multiprecision arithmetic library
ii  libmpc2                0.9-2             multiple precision complex floatin
ii  libmpfr4               3.0.0-9           multiple precision floating-point 
ii  mingw-w64-dev          1.0+20101003-1    Development files for MinGW-w64
ii  zlib1g                 1:1.2.5.dfsg-1    compression library - runtime

Versions of packages gcc-mingw-w64 recommends:
pn  gcc-4.5-locales               <none>     (no description available)
ii  libstdc++6-4.5-dev            4.5.2-8    The GNU Standard C++ Library v3 (d

gcc-mingw-w64 suggests no packages.

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, unknown-package@qa.debian.org:
Bug#622276; Package gcc-mingw-w64. (Mon, 11 Apr 2011 22:24:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stephen Kitt <steve@sk2.org>:
Extra info received and forwarded to list. Copy sent to unknown-package@qa.debian.org. (Mon, 11 Apr 2011 22:24:03 GMT) Full text and rfc822 format available.

Message #10 received at 622276@bugs.debian.org (full text, mbox):

From: Stephen Kitt <steve@sk2.org>
To: Adam Borowski <kilobyte@angband.pl>, 622276@bugs.debian.org
Subject: Re: Bug#622276: gcc-mingw-w64: architecture triplets don't seem to make sense
Date: Tue, 12 Apr 2011 00:21:54 +0200
Hi Adam,

On Mon, Apr 11, 2011 at 07:14:32PM +0200, Adam Borowski wrote:
> (Reporting while the package is still stuck in NEW, sorry if it becomes
> misplaced.  Reportbug claims the maintainer is ok, not sure about
> the BTS.)

Everything seems to have worked OK, although the BTS is slightly
confused. If you want to you can reassign the bug to mingw-w64 which
is in the archive already!

> The compiler triplets seem to be wrong:
> 
> * i686-w64-mingw32 has "w64" in name, yet executables it produces work
>   perfectly on 32 bit systems.  I even checked on an ancient 32 bit only   
>   machine to be 100% sure.
> 
>   To add confusion, other builds call it i586-mingw32msvc or just mingw32.
> 
> * x86_64-w64-mingw32 has "w32", but its executables are 64 bit.

This is how the upstream project (MinGW-w64) goes about things. There
are at least two reasons:
* The "w64" part is to identify the triplet as corresponding to
  MinGW-w64 as opposed to MinGW.
* The "mingw32" part is maintained so that existing configure scripts
  will still work (in particular, configure scripts written with MinGW
  in mind will work with MinGW-w64).

The MinGW-w64 project itself targets both 32- and 64-bit Windows. The
target is identified by its CPU (i[3456]86 for 32-bit, x86_64 for
64-bit); the API isn't supposed to change much... The "other builds"
calling it i586-mingw32msvc or i586-mingw32 are builds of MinGW, not
MinGW-w64 (and MinGW-w64 is a separate project from MinGW, not MinGW's
64-bit variant).

The triplets are those officially recognised by the various GNU
projects involved as well (binutils and gcc mainly), and are already
used in other distributions (notably Fedora which has a whole bunch of
MinGW-w64 packages) and by lots of downstream software (see the list
for instance on http://mingw-w64.sf.net).

> Not to mention the whole package being named *-mingw-w64 while its existing
> counterparts have "-w" less (-mingw32), but that'd be probably too much work
> to change at this point.  This inconsistency has nowhere as big potential
> for confusion as -w64- in the 32 bit compiler.

The mingw32 packages are based on MinGW, not MinGW-w64. The old
MinGW-w64 package using MinGW's binutils and gcc was supposed to be a
short-term hack and was eventually abandoned. The long term plan is
actually to get rid of the mingw32 packages, once the packages which
build-depend on them have been updated to build with mingw-w64 instead
(including for 32-bit Windows).

All this has been discussed with both upstream and MinGW's maintainer
in Debian. I realise it's not ideal, but many users of MinGW-w64 are
already used to this way of doing things...

Regards, and thanks for your interest,

Stephen




Added tag(s) wontfix. Request was from Stephen Kitt <steve@sk2.org> to control@bugs.debian.org. (Sun, 09 Oct 2011 21:24:03 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 02:50:11 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.